package org.ferris.dyndns.jmce.main;

import java.util.LinkedList;
import java.util.Properties;

import org.ferris.dyndns.jmce.jobs.DyndnsJob;
import org.ferris.dyndns.jmce.util.PropertiesFactory;


public class DyndnsTest 
{
    public static final void main(String[] args)
	throws Exception 
	{
        //String host = "localhost", port = "7777";
        //String host = "cacheflow.carenet.org", port = "8080";
        //String host = "bjcproxy01", port = "8080";
                
//        System.setProperty("http.proxyHost", host);
//        System.setProperty("http.proxyPort", port);
   
        
//        HttpRequestRunner.proxyAuthScope 
//            //= new AuthScope(host, Integer.parseInt(port), AuthScope.ANY_REALM, "ntlm")
//            = new AuthScope(host, Integer.parseInt(port), "carenet.org")
//        ;            
//        HttpRequestRunner.proxyCredentials
//            //= new NTCredentials("mjr2586", "Bu28olXu1v7", "BJC11166624.bjc-nt.bjc.org", "bjc-nt.bjc.org")
//            //= new NTCredentials("BJC-NT\\mjr2586", "Bu28olXu1v7", "BJC11166624.bjc-nt.bjc.org", "bjc-nt.bjc.org")
//            //= new NTCredentials("BJC-NT\\mjr2586", "Bu28olXu1v7", "BJC11166624.bjc-nt.bjc.org", "BJC-NT")
//            = new NTCredentials("BJC-NT\\mjr2586", "Bu28olXu1v7", null, "BJC-NT")
//        ;
        
       
        String username
            = getProperty("dyndns.username");
        
        String password
            = getProperty("dyndns.password");
        
        if (!missingProperties.isEmpty()) {
            StringBuilder sp = new StringBuilder();
            sp.append("\n~~~~~~~~~ MISSING SYSTEM PROPERTIES ~~~~~~~~~\n");
            for (String s : missingProperties) {
                sp.append("-D").append(s).append("\n");
            }
            throw new RuntimeException(sp.toString());
        }
        
        Properties properties
            = new Properties();
        properties.setProperty("username", username);
        properties.setProperty("password", password);
        
        PropertiesFactory.setProperties(properties);
        
        System.setProperty("org.ferris.dyndns.jmce.mail.isMailEnabled", "false");
		DyndnsJob job = new DyndnsJob();		
		job.execute(null);
		
		if (job.getErrors().size() > 0) {
			for (String err : job.getErrors()) {
				System.out.println("<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>");
				System.out.println(err);
				System.out.println("<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>");
			}
		}
				if (0 != job.getErrors().size()) {
            throw new RuntimeException("Errors returned, see above");
        }
	}
    
    private static LinkedList<String> missingProperties = new LinkedList<String>();
    private static String getProperty(String key) {
        String property
            = System.getProperty(key, "----");
        if (property.equals("----")) {
            missingProperties.add(key);
        }
        return property;
    }
}
