package org.ferris.dyndns.jmce.main;

import org.apache.log4j.Logger;
import org.ferris.dyndns.jmce.jobs.DyndnsJob;
import org.quartz.JobDetail;
import org.quartz.Scheduler;
import org.quartz.Trigger;
import org.quartz.TriggerUtils;
import org.quartz.impl.StdSchedulerFactory;


public class Main 
{
	private static final Logger log = Logger.getLogger(Main.class);
	
	/**
	 * @param args
	 */
	public static void main(String[] args) 	
	{		
		try {
			new Main(args);
		} catch (Throwable e) {
			log.fatal(e.getMessage(),e);
			e.printStackTrace();
		}
	}
	
	
	
	public Main(String[] args) throws Throwable
	{
		log.info("The main() method of Dyndns JMCE has been called");
	
		if (args.length > 0) {
			String arg0 = args[0];
			if (arg0.equals("--nojmce")) {
				new DyndnsJob().execute(null);
			}
		} else {
			two();
		}
	}
	
	private void two()
	throws Exception {
		//	Grab the Scheduler instance from the Factory 
		log.info("Create Scheduler");
        Scheduler scheduler = StdSchedulerFactory.getDefaultScheduler();

		log.info("Create JobDetail");
		JobDetail jobDetail 
			= new JobDetail(
				DyndnsJob.class.getSimpleName(),
			    null,
			    DyndnsJob.class
			);
		
		log.info("Create Trigger");
		Trigger trigger 
		    //= TriggerUtils.makeMinutelyTrigger(DyndnsJob.class.getSimpleName());
		    = TriggerUtils.makeDailyTrigger(DyndnsJob.class.getSimpleName(),3,0); //3am
		
		log.info("Schedule job");
		scheduler.scheduleJob(jobDetail, trigger);
		
        log.info("Start scheduler");
        scheduler.start();
	}
}
